LeetCode-1. Two Sum

1. 问题描述

Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

2. 解法描述

2.1 暴力穷举

进行两层遍历,满足题目要求的条件时退出。
显然该算法的时间复杂度为 O(n2) ,空间复杂度为 O(1)

public int[] twoSum1(int[] nums, int target) {
        int[] result = new int[]{0,0}; 
        for(int i = 0; i < nums.length - 1; i ++ ) {
            for (int j = i + 1; j < nums.length; j ++) {
                if ((nums[i] + nums[j]) == target) {
                    result[0] = i;
                    result[1] = j;
                    break;
                }
            }
        }

        return result;
    }

更加优雅的版本:

public int[] twoSum2(int[] nums, int target) {
        for (int i = 0; i < nums.length; i++) {
            for (int j = i + 1; j < nums.length; j++) {
                if (nums[j] == target - nums[i]) {
                    return new int[] { i, j };
                }
            }
        }
        throw new IllegalArgumentException("No two sum solution");
    }

2.2 优化

暴力穷举法使用了两层遍历,其中第二层遍历的目的是为了寻找数组中是否存在某元素,若存在,则返回的结果是该元素在数组中对应的下标,其时间复杂度为 O(n) 。显然,此处通过HashMap来优化,因为在HashMap检测某元素是否存在的时间复杂度为 O(1)

优化版:

public int[] twoSum3(int[] nums, int target) {
        Map<Integer, Integer> value2index = new HashMap<>();

        for (int i = 0; i < nums.length; i ++) {
            value2index.put(nums[1], i);
        }

        for (int i = 0; i < nums.length; i ++) {
            int key = target - nums[i];
            if (value2index.containsKey(key) && value2index.get(key) != i) {
                return new int[]{i, value2index.get(key)};
            }
        }

        throw new IllegalArgumentException("No two sum solution");
    }

该算法时间复杂度为 O(n+n)O(n) ,空间复杂度为 O(n)

优雅版:

public int[] twoSum4(int[] nums, int target) {
        Map<Integer, Integer> value2index = new HashMap<>();
        for(int i = 0; i < nums.length; i ++) {
            int key = target - nums[i];
            if(value2index.containsKey(key)) {
                int index = value2index.get(key);
                return new int[]{index, i};
            }
            value2index.put(nums[i], i);
        }
        throw new IllegalArgumentException("no two sum solution");
    }

参考

Two Sum

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值